'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Popover = require('material-ui/Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _Menu = require('material-ui/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Chip = require('material-ui/Chip');

var _Chip2 = _interopRequireDefault(_Chip);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var hrWithOutTransition = {
  borderStyle: 'none none solid',
  borderBottomWidth: '2px',
  borderColor: 'rgb(0, 188, 212)',
  boxSizing: 'content-box',
  margin: '0px',
  width: '100%',
  transform: 'scaleX(0)',
  transition: 'all 450ms cubic-bezier(0.23, 1, 0.32, 1) 0ms',
  backgroundColor: 'white'
};

var hrTransition = {
  transform: 'scaleY(1)'
};

var inputHr = {
  borderStyle: 'none none solid',
  borderBottomWidth: '1px',
  borderColor: 'rgb(224, 224, 224)',
  boxSizing: 'content-box',
  margin: '0px',
  width: '100%',
  marginTop: '-8px'
};

var MultiSelect = function (_Component) {
  _inherits(MultiSelect, _Component);

  function MultiSelect(props) {
    _classCallCheck(this, MultiSelect);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(MultiSelect).call(this, props));

    _this.handleRequestDelete = function (value) {

      _this.selectedItems = _this.state.selectedItems;
      var itemToDelete = _this.selectedItems.map(function (item) {
        return item.value;
      }).indexOf(value);
      _this.selectedItems.splice(itemToDelete, 1);
      _this.setState({ selectedItems: _this.selectedItems });
    };

    _this.handleFocus = function () {

      _this.setState({
        anchorEl: _reactDom2.default.findDOMNode(_this.refs.inputFieldCont),
        showTransition: true,
        focusTextField: true,
        filterSuggestions: []
      });
    };

    _this.handleBlur = function () {
      if (_this.state.focusTextField) {
        _this.close();

        _this.setState({
          focusTextField: false
        });
      }
    };

    _this.close = function () {

      _this.setState({
        isOpen: false,
        anchorEl: null,
        showTransition: false
      });
    };

    _this.displayAll = function () {
      _this.setState({
        filterSuggestions: _this.state.suggestions,
        isOpen: true
      });
    };

    _this.handleKeyDown = function (event) {
      if ((0, _keycode2.default)(event) === 'enter') {
        _this.displayAll();
      }
    };

    _this.filterData = function (value) {
      return _this.state.suggestions.filter(function (suggestion) {
        return _lodash2.default.includes(suggestion.value, value);
      });
    };

    _this.handleChangeText = function (e, value) {

      if (!_lodash2.default.isEmpty(_this.filterData(value)) && !_this.state.isOpen) {

        _this.setState({
          isOpen: true
        });
      }

      _this.setState({
        filterSuggestions: _this.filterData(value),
        currentText: value
      });
    };

    _this.closeDropdown = function () {

      _this.setState({
        isOpen: false
      });
    };

    _this.onSelection = function (event, menuItem, index) {

      // this.props.addToSelectedItems(event, menuItem.props.value, index)

      _this.setState({
        currentText: ''
      });

      _this.refs['textInput'].focus();
    };

    _this.state = {
      suggestions: _this.props.suggestionItems,
      selectedItems: _this.props.selectedItems,
      currentText: '',
      isOpen: false,
      focusTextField: true,
      showTransition: false,
      filterSuggestions: []
    };
    return _this;
  }

  _createClass(MultiSelect, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var hintText = this.props.hintText;
      var _state = this.state;
      var currentText = _state.currentText;
      var isOpen = _state.isOpen;
      var selectedItems = _state.selectedItems;
      var focusTextField = _state.focusTextField;
      var showTransition = _state.showTransition;
      var anchorEl = _state.anchorEl;
      var filterSuggestions = _state.filterSuggestions;


      var hrClasses = showTransition ? _lodash2.default.merge(hrWithOutTransition, _lodash2.default.clone(hrTransition)) : hrWithOutTransition;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'dropdownContainer', style: { width: '80%' } },
          _react2.default.createElement(
            'div',
            { ref: 'inputFieldCont', style: { width: '100%', marginTop: '19px', display: 'flex', alignItems: 'center', paddingBottom: 4 } },
            selectedItems.map(function (item, key) {

              return _react2.default.createElement(
                _Chip2.default,
                {
                  key: key,
                  onRequestDelete: function onRequestDelete() {
                    return _this2.handleRequestDelete(item.value);
                  },
                  style: { margin: 3 }
                },
                item.label
              );
            }),
            _react2.default.createElement(_TextField2.default, {
              id: 'inputField',
              ref: 'textInput',
              value: currentText,
              autoComplete: 'off',
              hintText: _lodash2.default.capitalize(hintText),
              style: { width: '22%', marginRight: 2 },
              onKeyDown: this.handleKeyDown,
              onChange: this.handleChangeText,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur,
              underlineShow: false
            })
          ),
          _react2.default.createElement('hr', { style: inputHr }),
          _react2.default.createElement('hr', { style: hrClasses })
        ),
        _react2.default.createElement(
          _Popover2.default,
          {
            open: isOpen,
            useLayerForClickAway: false,
            style: { width: '50%' },
            anchorEl: anchorEl,
            anchorOrigin: { horizontal: 'left', vertical: 'bottom' },
            targetOrigin: { horizontal: 'left', vertical: 'top' },
            onRequestClose: this.closeDropdown
          },
          _react2.default.createElement(
            _Menu2.default,
            {
              multiple: _lodash2.default.isArray(selectedItems),
              onItemTouchTap: this.onSelection,
              disableAutoFocus: focusTextField,
              desktop: true,
              value: selectedItems,
              maxHeight: 250,
              style: { overflowY: 'auto', overflowX: 'auto' }
            },
            filterSuggestions.map(function (suggestion, i) {
              return _react2.default.createElement(_MenuItem2.default, { key: i, primaryText: suggestion.label, value: suggestion });
            })
          )
        )
      );
    }
  }]);

  return MultiSelect;
}(_react.Component);

exports.default = MultiSelect;
